<template>
  <div class="user">
    <searchBox :btn-option-list="btnOptionList" @operateForm="operateForm"></searchBox>

    <div class="content-table">
      <ComTable
        :columns="columns"
        :table-data="tableData"
        @handlePagesizeChange="handlePagesizeChange"
        ref="comTable"
        :table-option="tableOption"
        :page-option="pageOption"
      >
        <template #gender="record">
          <!-- 0:女; 1:男 -->
          <span>{{ ['女', '男'][record.gender] }}</span>
        </template>

        <template #action="record">
          <OperateCom :record="record" :operate-list="operateList" @operateForm="operateForm" />
        </template>
      </ComTable>
    </div>
    <a-modal
      v-model:open="formModal"
      width="750px"
      style="top: 80px"
      :footer="null"
      :destroy-on-close="true"
    >
      <!-- action:edit add -->
      <EditCom
        :record="record"
        @operateForm="operateForm"
        type="user"
        :action="formStatus"
      ></EditCom>
    </a-modal>
  </div>
</template>

<script>
import { columnList, userOptions } from '../../../public/config/columnList'
import { getReq, postReq } from '@/request/api.js'
import EditCom from '@/components/EditCom.vue'
import { ExclamationCircleOutlined } from '@ant-design/icons-vue'
import { Modal } from 'ant-design-vue'
import { createVNode } from 'vue'
export default {
  name: '',
  components: {
    EditCom
  },
  props: {},
  data() {
    return {
      tableData:[],
      tableOption: {
        select: false
      },
      formModal: false,
      formState: {},
      formStatus: 'add', //表单状态辑状态 add:新增 edit:编辑
      pageOption: {
        pageSize: 10,
        page: 1
      },
      btnOptionList: [],
      paramsDate: {}
    }
  },
  computed: {},
  created() {
    let info = []
    let col = columnList.find((i) => i.page == 'user').columns
    if (col.length) {
      col.forEach((item) => {
        info.push(this.$setWidth(item))
      })
    }
    this.columns = info
  },

  mounted() {
    this.operateList = this.$getBtns(['查看', '修改', '删除'])
    this.btnOptionList = this.$getBtns(['新增'])
    this.getList()
  },

  methods: {
    async getList() {
      this.$refs.comTable.loading = true

      const { page, pageSize } = this.pageOption

      const params = {
        ...this.paramsDate,
        page_size: pageSize,
        page
      }

      try {
        const res = await getReq('/queryUserList', params)
        if (res.errcode === 0) {
          this.$refs.comTable.loading = false

          this.tableData = res.data

          this.pageOption = {
            page: res.page,
            pageSize: res.page_size,
            count: res.count
          }
        } else {
          const err = { tip: res.errmsg }
          throw err
        }
      } catch (error) {
        this.$refs.comTable.loading = false

        //统一处理报错提示
      }
    },
    operateForm(type, record = {}) {
      this.formStatus = type
      switch (type) {
      case 'add':
        this.formModal = true
        this.formState = {}
        this.getRuleFormInfo()

        break
      case 'edit':
      case 'read':
        this.formModal = true
        this.formState = record
        this.getRuleFormInfo(record)
        break

      case 'del':
        this.handleDelete([record.user_id], this.getList)

        break

      case 'back':
        this.formModal = false
        this.getList()
        break

      default:
        break
      }
    },
    //  删除操作
    async handleDelete(id, callback) {
      const that = this
      this.$Modal.confirm({
        title: '你确认删除数据吗?',
        icon: createVNode(ExclamationCircleOutlined),

        async onOk() {
          try {
            const res = await getReq('/deleteUser', { user_id: id })
            if (res.errcode === 0) {
              this.$message.success(res.errmsg)
              this.pageOption.page = 1
              callback()
            } else {
              throw res
            }
          } catch (error) {
            callback()
          }
        },
        onCancel() {},
        class: 'test'
      })
    },
    async getRuleFormInfo(record) {
      function getInfo(data, url) {
        return new Promise((reslove, reject) => {
          getReq(data, url).then((res) => {
            reslove(res.data)
          })
        })
      }

      let row = {}
      if (record && record.user_id) {
        // row = await getInfo({ id: record.id },'/queryUserList')
        this.record = record
        row = record
        // this.type='edit'
      }
      userOptions.forEach((e, index) => {
        e.list.forEach((i) => {
          e.ruleForm[i.key] = row ? row[i.key] : ''
          e.ruleForm.id = row.id
        })
      })
    },
    handlePagesizeChange(pageOption) {
      this.pageOption.pageSize = pageOption.pageSize
      this.pageOption.page = pageOption.page
      this.getList()
    }
  }
}
</script>

<style lang="scss" scoped>
.user {
  height: 100%;
  padding:  20px;
  .content-table {
    height: calc(100% - 52px);
  }
}
</style>
